﻿using System;
using System.Collections.Generic;
using System.Text;

namespace MailServer.Exceptions
{
    class NotFoundException : Exception
    {
        public Type Type { get; set; }

        public NotFoundException(Type type) : base()
        {
            Type = type;
        }

        public NotFoundException(string message, Type type) : base(message)
        {
            Type = type;
        }

        public NotFoundException(string message, Exception inner, Type type) : base(message, inner)
        {
            Type = type;
        }
    }

    public enum Type
    {
        DOMAIN,
        ACCOUNT,
        ALIAS,
        MAIL,
        FOLDER
    }
}
